var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import ExcelJS from 'exceljs';
var decode = function (value) {
    if (typeof value === 'string') {
        var textarea = document.createElement('textarea');
        textarea.innerHTML = value;
        return textarea.value;
    }
    return value;
};
var prepareData = function (data, columns) {
    var validCols = columns.filter(function (c) { return (c === null || c === void 0 ? void 0 : c.field) && (c === null || c === void 0 ? void 0 : c.header_text); });
    var headers = validCols.map(function (c) { return c.header_text; });
    var rows = data.map(function (row) { return validCols.map(function (col) { var _a; return decode((_a = row[col.field]) !== null && _a !== void 0 ? _a : ''); }); });
    return { headers: headers, rows: rows };
};
var getFileName = function () {
    var now = new Date();
    var pad = function (n) { return n.toString().padStart(2, '0'); };
    return ("Data.".concat(now.getFullYear()).concat(pad(now.getMonth() + 1)).concat(pad(now.getDate())) +
        ".".concat(pad(now.getHours())).concat(pad(now.getMinutes())).concat(pad(now.getSeconds()), ".xlsx"));
};
export var downloadExcel = function (_a) { return __awaiter(void 0, [_a], void 0, function (_b) {
    var workbook, sheet_1, headers_1, rows, columns, result, buffer, blob, err_1;
    var data = _b.data, setupData = _b.setupData;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _c.trys.push([0, 2, , 3]);
                workbook = new ExcelJS.Workbook();
                sheet_1 = workbook.addWorksheet('Sheet1');
                headers_1 = [];
                rows = [];
                columns = (setupData === null || setupData === void 0 ? void 0 : setupData.excel_columns) || (setupData === null || setupData === void 0 ? void 0 : setupData.columns) || [];
                if (columns.length > 0) {
                    result = prepareData(data, columns);
                    headers_1 = result.headers;
                    rows = result.rows;
                }
                else {
                    headers_1 = Object.keys(data[0] || {});
                    rows = data.map(function (row) { return headers_1.map(function (h) { var _a; return decode((_a = row[h]) !== null && _a !== void 0 ? _a : ''); }); });
                }
                sheet_1.addRow(headers_1);
                rows.forEach(function (row) { return sheet_1.addRow(row); });
                return [4, workbook.xlsx.writeBuffer()];
            case 1:
                buffer = _c.sent();
                blob = new Blob([buffer], {
                    type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
                });
                return [2, { blob: blob, fileName: getFileName() }];
            case 2:
                err_1 = _c.sent();
                alert('Lỗi khi tạo file Excel: ' + err_1);
                return [3, 3];
            case 3: return [2];
        }
    });
}); };
